/*
* common.h - this file includes and prototypes micro specific functions
* Copyright 2006-2008 OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* Version 2.4 by Andii
*/

#ifndef COMMON_H
#define COMMON_H

#include "../chiip/archdep.h"
#include "serial.h"

void machInit(void);	// setup machine dependend stuff not covered elsewhere

// we dont even use these but hey, they are here
#define GCFORMAT 	0x0040 // gc format
#define WIIFORMAT 	0x0080 // wii format
#define NOTSINGLE	0x0100 // 0-single
#define PTPDISC		0x0200 // ptp disc
#define OTPDISC		0x0400 // otp disc
#define REALDISC	0x0800 // real disc
#define EMUDISC		0x1000 // emu disc
#define DISC120		0x4000 // 0=80mmdisc,1=120mm

#define EEP_REGION	(void*)0x00	// region EEPROM address
#define EEP_SPEED	(void*)0x01	// speed / audiofix EEPROM address

// dms/d2a drive chip firmware
extern const uint8_t BINARYSTARTDMS;
extern const void BINARYSIZEDMS;

// d2b drive chip firmware
extern const uint8_t BINARYSTARTD2B;
extern const void BINARYSIZED2B;

#endif	// COMMON_H
